## hurd 0.9.git20180305

=== Makefile ===
#
#   Copyright (C) 1993, 1994, 1995, 1996, 1997, 1998, 1999, 2001, 2002, 2004,
#   2006, 2009, 2011, 2012, 2013 Free Software Foundation, Inc.
#
#   This program is free software; you can redistribute it and/or
#   modify it under the terms of the GNU General Public License as
#   published by the Free Software Foundation; either version 2, or (at
#   your option) any later version.
#
#   This program is distributed in the hope that it will be useful, but
#   WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

dir := .
makemode := misc

DISTFILES := configure

include ./Makeconf

## Subdirectories of this directory should all be mentioned here

# Hurd libraries
lib-subdirs = libshouldbeinlibc libihash libiohelp libports libthreads \
	      libpager libfshelp libdiskfs libtrivfs libps \
	      libnetfs libpipe libstore libhurdbugaddr libftpconn libcons \
	      libhurd-slab \
	      libbpf \

# Hurd programs
prog-subdirs = auth proc exec term \
	       ext2fs isofs tmpfs fatfs \
	       storeio pflocal pfinet defpager mach-defpager \
	       login daemons boot console \
	       hostmux usermux ftpfs trans \
	       console-client utils sutils \
	       benchmarks fstests \
	       procfs \
	       startup \
	       init \
	       devnode \
	       eth-multiplexer \

ifeq ($(HAVE_SUN_RPC),yes)
prog-subdirs += nfs nfsd
endif

ifeq ($(HAVE_LIBLWIP),yes)
prog-subdirs += lwip
endif

# Other directories
other-subdirs = hurd doc config release include

# All the subdirectories together
subdirs = $(lib-subdirs) $(prog-subdirs) $(other-subdirs)

# This allows the creation of a file BROKEN in any of the prog-subdirs;
# that will prevent this top level Makefile from attempting to make it.
working-prog-subdirs := $(filter-out \
			  $(patsubst %/,%,\
				 $(dir $(wildcard $(prog-subdirs:=/BROKEN)))),\
			  $(prog-subdirs))


$(subdirs): version.h

## GNU Coding Standards targets (not all are here yet), and some other
## similar sorts of things

all: $(lib-subdirs) $(working-prog-subdirs)

# Create a distribution tar file.

git_describe := git describe --match '*release*'
dist-version := $(shell cd $(top_srcdir)/ && $(git_describe))

.PHONY: dist
ifdef configured
dist: $(foreach Z,bz2 gz,$(dist-version).tar.$(Z))
else
dist:
	@echo >&2 'Cannot build a distribution from an unconfigured tree.'
	false
endif

HEAD.tar: FORCE
	cd $(top_srcdir)/ && git status --short \
	  | $(AWK) '{ print; rc=1 } END { exit rc }' \
	  || { echo >&2 \
		'Refusing to build a distribution from dirty sources.' && \
		false; }
	(cd $(top_srcdir)/ && git archive --prefix=$(dist-version)/ HEAD) > $@

ChangeLog.tar: gen-ChangeLog
	tar -c -f $@ --owner=0 --group=0 \
	  --transform='s%^%$(dist-version)/%' $(ChangeLog_files)

# See the ChangeLog file.
gitlog-to-changelog_rev = \
  2772f5c6a6a51cf946fd95bf6ffe254273157a21..
ChangeLog_files = \
  $(filter-out :%,$(subst :, :,$(ChangeLog_specs)))
ChangeLog_specs = \
  ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  auth/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  benchmarks/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  boot/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  config/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  console-client/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  console/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  daemons/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  defpager/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  doc/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  exec/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  ext2fs/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  fatfs/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  fstests/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  ftpfs/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  hostmux/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  hurd/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  include/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  init/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  isofs/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  libcons/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  libdirmgt/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  libdiskfs/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  libfshelp/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  libftpconn/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  libhurdbugaddr/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  libihash/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  libiohelp/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  libnetfs/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  libpager/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  libpipe/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  libports/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  libps/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  libshouldbeinlibc/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  libstore/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  libthreads/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  libtrivfs/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  login/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  mach-defpager/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  nfs/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  nfsd/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  pfinet/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  pflocal/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  proc/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  release/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  storeio/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  sutils/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  term/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  tmpfs/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  trans/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  usermux/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21 \
  utils/ChangeLog:2772f5c6a6a51cf946fd95bf6ffe254273157a21
# procfs
gitlog-to-changelog_rev += \
  ^aac4aaf42372f61c78061711916c81a9d5bcb42d~1
ChangeLog_specs += \
  procfs/ChangeLog:edb4593c38d421b5d538b221a991b50c36fdba15:ChangeLog
# random
gitlog-to-changelog_rev += \
  ^1ba2ed95690396bf081d0af043d878b26b8563c2~1
# Specify dummy ChangeLog file, will get overwritten.
ChangeLog_specs += \
  random/ChangeLog:HEAD:ChangeLog
.PHONY: gen-ChangeLog
gen-ChangeLog:
	$(AM_V_GEN)if test -d $(top_srcdir)/.git; then			\
	  rm -f $(ChangeLog_files) &&					\
	  (cd $(top_srcdir)/ &&						\
	  ./gitlog-to-changelog	--strip-tab				\
	    $(gitlog-to-changelog_rev) &&				\
	  echo) >> ChangeLog &&						\
	  (cd $(top_srcdir)/ &&						\
	  ./gitlog-to-changelog --strip-tab				\
	    edb4593c38d421b5d538b221a991b50c36fdba15..aac4aaf42372f61c78061711916c81a9d5bcb42d~1 && \
	  echo) >> procfs/ChangeLog &&					\
	  rm -f random/ChangeLog-1 &&					\
	  (cd $(top_srcdir)/ &&						\
	  ./gitlog-to-changelog --strip-tab				\
	    ac38884dc9ad32a11d09f55ba9fe399cd0a48e2f..1ba2ed95690396bf081d0af043d878b26b8563c2~1 && \
	  echo) >> random/ChangeLog-1 &&				\
	  for cs in $(ChangeLog_specs); do				\
	    f=$${cs%%:*} &&						\
	    s=$${cs#$$f:} && s_f=$$s:$$f && s=$${s_f/*:*:*/$$s} &&	\
	    (cd $(top_srcdir)/ &&					\
	    git show $$s) >> $$f					\
	    || exit $$?;						\
	  done &&							\
	  rm -f random/ChangeLog_ &&					\
	  (cd $(top_srcdir)/ &&						\
	  git ls-tree --name-only					\
	    ac38884dc9ad32a11d09f55ba9fe399cd0a48e2f) >> random/ChangeLog_ && \
	  rm -f random/ChangeLog-2 &&					\
	  perl \
	    -e 'print "2011-08-18  Gaël Le Mignot  <kilobug\@freesurf.fr>\n\n"; while(<>){s%^%\t* %;s%$$%: New file.%;print;}' \
	    < random/ChangeLog_ > random/ChangeLog-2 &&			\
	  cat random/ChangeLog-* > random/ChangeLog &&			\
	  rm random/ChangeLog?* &&					\
	  sed								\
	    -e 's%\* [ ]*%* procfs/%'					\
	    -e s%procfs/procfs/%procfs/%				\
	    -i procfs/ChangeLog &&					\
	  sed								\
	    -e 's%\* [ ]*%* random/%'					\
	    -i random/ChangeLog;					\
	fi

$(dist-version).tar: HEAD.tar $(addsuffix /dist-hook,hurd/.. $(subdirs)) ChangeLog.tar
	tar -c -f $@ --files-from=/dev/null
# Concatenate the tar files.  Have
# to do it one by one: <http://savannah.gnu.org/patch/?7757>.
	for f in HEAD.tar dist.tar */dist.tar ChangeLog.tar; do \
	  tar -v --concatenate -f $@ "$$f"; \
	done

clean: $(addsuffix -clean,$(subdirs)) clean-misc

relink: $(addsuffix -relink,$(lib-subdirs) $(prog-subdirs))

objs: $(addsuffix -objs,$(lib-subdirs) $(prog-subdirs))

install: $(addsuffix -install,$(lib-subdirs) $(working-prog-subdirs) \
	   $(other-subdirs))

install-headers: $(addsuffix -install-headers,$(lib-subdirs) \
		$(working-prog-subdirs)\
		$(other-subdirs))

TAGS: $(addsuffix -TAGS,$(working-prog-subdirs) $(lib-subdirs))
	etags -o $@ $(patsubst %-TAGS,-i %/TAGS,$^)

%.bz2: %
	bzip2 -9 < $< > $@

%.gz: %
	gzip -9n < $< > $@

## Targets used by the main targets above.
$(prog-subdirs) $(lib-subdirs): FORCE
	$(MAKE) -C $@ all
FORCE:

%-clean:
	$(MAKE) -C $* clean no_deps=t

%-relink:
	$(MAKE) -C $* relink no_deps=t

%-objs:
	$(MAKE) -C $* objs

%-install:
	$(MAKE) -C $* install

%-install-headers:
	$(MAKE) -C $* install-headers

%-TAGS:
	$(MAKE) -C $* TAGS no_deps=t

.PHONY: %/dist-hook
%/dist-hook:
	$(MAKE) -C $* dist-hook no_deps=t dist-version=$(dist-version)

.PHONY: clean-misc distclean
clean-misc:
	rm -f HEAD.tar ChangeLog.tar $(ChangeLog_files)

distclean: clean
	rm -f config.make config.log config.status config.cache
ifneq (.,${srcdir})
	rm -f Makefile
endif


## Directory dependencies
#
# Some directories depend on others, so we need to find out exactly
# what they are.  This does that for us.

ifneq ($(no_deps),t)
-include $(addsuffix .d,$(subdirs))
endif

# How to build them
$(addsuffix .d,$(subdirs)): %.d: $(top_srcdir)/%/Makefile
	$(MAKE) -C $* directory-depend no_deps=t


## Build system

AUTOCONF = autoconf
AUTOCONF_FLAGS = -I $(top_srcdir)

$(top_srcdir)/configure: $(top_srcdir)/configure.ac $(top_srcdir)/aclocal.m4
	$(AUTOCONF) $(AUTOCONF_FLAGS) $< > $@
	chmod +x $@

config.status: $(top_srcdir)/configure
	$(SHELL) $@ --recheck

config.make: config.status $(top_srcdir)/config.make.in
# No stamp file is used here, as config.make's timestamp changing will not have
# any far-reaching consequences.
	$(SHELL) $< --file=$@

version.h: stamp-version; @:
stamp-version: version.h.in config.make
	sed -e 's/MASTER_HURD_VERSION/\"$(package-version)\"/' \
	  < $< > version.h.new
	$(move-if-change) version.h.new version.h
	touch $@

=== lwip/Makefile ===
#   Copyright (C) 2017 Free Software Foundation, Inc.
#
#   This file is part of the GNU Hurd.
#
#   The GNU Hurd is free software; you can redistribute it and/or
#   modify it under the terms of the GNU General Public License as
#   published by the Free Software Foundation; either version 2, or (at
#   your option) any later version.
#
#   The GNU Hurd is distributed in the hope that it will be useful, but
#   WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with the GNU Hurd.  If not, see <http://www.gnu.org/licenses/>.

dir		= lwip
makemode	= server

PORTDIR = $(srcdir)/port

SRCS		= main.c io-ops.c socket-ops.c pfinet-ops.c iioctl-ops.c port-objs.c \
		  startup-ops.c options.c lwip-util.c startup.c
IFSRCS		= ifcommon.c hurdethif.c hurdloopif.c hurdtunif.c
MIGSRCS		= ioServer.c socketServer.c pfinetServer.c iioctlServer.c \
		  startup_notifyServer.c
OBJS		= $(patsubst %.S,%.o,$(patsubst %.c,%.o,\
		  $(SRCS) $(IFSRCS) $(MIGSRCS)))

HURDLIBS = trivfs fshelp ports ihash shouldbeinlibc iohelp
LDLIBS = -lpthread $(liblwip_LIBS)

target = lwip

include ../Makeconf

vpath %.c $(PORTDIR) $(PORTDIR)/netif

CFLAGS += -I$(PORTDIR)/include $(liblwip_CFLAGS)

MIGCOMSFLAGS += -prefix lwip_
mig-sheader-prefix = lwip_
io-MIGSFLAGS = -imacros $(srcdir)/mig-mutate.h
socket-MIGSFLAGS = -imacros $(srcdir)/mig-mutate.h
iioctl-MIGSFLAGS = -imacros $(srcdir)/mig-mutate.h

# cpp doesn't automatically make dependencies for -imacros dependencies. argh.
lwip_io_S.h ioServer.c lwip_socket_S.h socketServer.c: mig-mutate.h
$(OBJS): config.h

=== utils/Makefile ===
#   Copyright (C) 1994,95,96,97,98,99,2000,01,02,12,14 Free Software Foundation,
#   Inc.
#
#   This program is free software; you can redistribute it and/or
#   modify it under the terms of the GNU General Public License as
#   published by the Free Software Foundation; either version 2, or (at
#   your option) any later version.
#
#   This program is distributed in the hope that it will be useful, but
#   WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

dir := utils
makemode := utilities

targets = shd ps settrans showtrans syncfs fsysopts \
	storeinfo login w uptime ids loginpr sush vmstat portinfo \
	devprobe vminfo addauth rmauth unsu setauth ftpcp ftpdir storecat \
	storeread msgport rpctrace mount gcore fakeauth fakeroot remap \
	umount nullauth rpcscan vmallocate

special-targets = loginpr sush uptime fakeroot remap
SRCS = shd.c ps.c settrans.c syncfs.c showtrans.c addauth.c rmauth.c \
	fsysopts.c storeinfo.c login.c loginpr.sh sush.sh w.c \
	uptime.sh psout.c ids.c vmstat.c portinfo.c devprobe.c vminfo.c \
	parse.c frobauth.c frobauth-mod.c setauth.c pids.c nonsugid.c \
	unsu.c ftpcp.c ftpdir.c storeread.c storecat.c msgport.c \
	rpctrace.c mount.c gcore.c fakeauth.c fakeroot.sh remap.sh \
	nullauth.c match-options.c msgids.c rpcscan.c

OBJS = $(filter-out %.sh,$(SRCS:.c=.o))
HURDLIBS = ps ihash store fshelp ports ftpconn shouldbeinlibc
LDLIBS += -lpthread
login-LDLIBS = -lutil -lcrypt
addauth-LDLIBS = -lcrypt
setauth-LDLIBS = -lcrypt
mount-LDLIBS = $(libblkid_LIBS)
mount-CPPFLAGS = $(libblkid_CFLAGS)

INSTALL-login-ops = -o root -m 4755
INSTALL-ids-ops = -o root -m 4755
INSTALL-ps-ops = -o root -m 4755
INSTALL-w-ops = -o root -m 4755

include ../Makeconf

ps addauth rmauth setauth unsu msgport: parse.o pids.o
login addauth setauth: nonsugid.o
addauth rmauth setauth unsu: frobauth.o
rmauth setauth unsu: frobauth-mod.o
ps w: psout.o ../libps/libps.a ../libihash/libihash.a
portinfo: ../libihash/libihash.a ../libps/libps.a

storeinfo storecat storeread: ../libstore/libstore.a
ftpcp ftpdir: ../libftpconn/libftpconn.a
mount umount: ../libihash/libihash.a
settrans: ../libfshelp/libfshelp.a ../libihash/libihash.a \
	../libports/libports.a
ps w ids settrans syncfs showtrans fsysopts storeinfo login vmstat portinfo \
  devprobe vminfo addauth rmauth setauth unsu ftpcp ftpdir storeread \
  storecat msgport mount umount nullauth rpctrace: \
	../libshouldbeinlibc/libshouldbeinlibc.a

$(filter-out $(special-targets), $(targets)): %: %.o

rpctrace: ../libports/libports.a
rpctrace rpcscan: msgids.o \
	  ../libihash/libihash.a \
	  ../libshouldbeinlibc/libshouldbeinlibc.a
msgids-CPPFLAGS = -DDATADIR=\"${datadir}\"

fakeauth: authServer.o auth_requestUser.o interruptServer.o \
	  ../libports/libports.a ../libihash/libihash.a \
	  ../libshouldbeinlibc/libshouldbeinlibc.a
auth-MIGSFLAGS = -imacros $(srcdir)/../auth/mig-mutate.h
fakeauth-CPPFLAGS = -I$(srcdir)/../auth
authServer-CPPFLAGS = -I$(srcdir)/../auth
auth_requestUser-CPPFLAGS = -I$(srcdir)/../auth

mount umount: ../sutils/fstab.o ../sutils/clookup.o match-options.o \
       $(foreach L,fshelp ports,../lib$L/lib$L.a)
../sutils/fstab.o ../sutils/clookup.o: FORCE
	$(MAKE) -C $(@D) $(@F)
FORCE:

shd vmallocate: ../libshouldbeinlibc/libshouldbeinlibc.a

=== lib/src_ip/Makefile ===
PKGDIR     ?= ../../..
L4DIR      ?= $(PKGDIR)/../..
CONTRIB    ?= $(PKGDIR)/linux26/contrib

-include $(PKGDIR_OBJ)/Makeconf

ifeq ($(CONFIG_DDE26_NET),y)
TARGET += libdde_linux26_net_ip.a
endif

SYSTEMS = x86-l4v2

ifeq ($(ARCH), x86)
ARCH_DIR = arch/i386
endif

# contrib sources are in $(CONTRIB)
vpath %.c     $(CONTRIB) $(PKGDIR)/linux26/lib/src
vpath %.S     $(CONTRIB) $(PKGDIR)/linux26/lib/src

PRIVATE_INCDIR += $(CONTRIB)/drivers/pci $(PKGDIR)/linux26/lib/src/arch/l4 \
                  $(CONTRIB)/$(ARCH_DIR)/pci $(CONTRIB)/drivers/base/ \
                  $(CONTRIB)/lib $(PKGDIR_OBJ) $(CONTRIB)/net/core

ifeq ($(ARCH), x86)
SRC_S_libdde_linux26_net_ip.a += $(ARCH_DIR)/lib/checksum.S
endif

SRC_C_libdde_linux26_net_ip.a += \
                              arch/l4/net.c \
                              drivers/net/mii.c \
                              net/core/skbuff.c \
                              net/core/utils.c \
                              net/core/dev.c \
                              net/core/ethtool.c \
                              net/core/link_watch.c \
                              net/core/dev_mcast.c \
                              net/core/neighbour.c \
                              net/core/netevent.c \
                              net/ethernet/eth.c \
                              net/sched/sch_generic.c \
                              arch/l4/inodes.c      \
                              mm/memory.c \
                              net/core/filter.c \
                              net/core/rtnetlink.c \
                              net/core/sock.c \
                              net/netlink/af_netlink.c \
                              net/netlink/attr.c

include $(PKGDIR)/linux26/Makeconf

include $(L4DIR)/mk/lib.mk

=== debian/changelog ===
hurd (1:0.9.git20180305-1) unstable; urgency=medium

  * New upstream snapshot.

 -- Samuel Thibault <sthibault@debian.org>  Tue, 06 Mar 2018 08:35:38 +0000

hurd (1:0.9.git20180222-1) unstable; urgency=medium

  * New upstream snapshot.
    - debian/patches/git-fix-sync: Merged.
    - debian/patches/git-proc_mounts_firmlink.patch: Merged.
    - debian/patches/git-rpcscan-link: Merged.
  * debian/rules: Preseed more symbols for rebootstrap.

 -- Samuel Thibault <sthibault@debian.org>  Thu, 22 Feb 2018 20:58:25 +0000

hurd (1:0.9.git20180108-2) unstable; urgency=medium

  * debian/patches/git-fix-sync: Cherry-pick fix sync at shutdown.

 -- Samuel Thibault <sthibault@debian.org>  Mon, 15 Jan 2018 21:10:10 +0000

hurd (1:0.9.git20180108-1) unstable; urgency=medium

  * New upstream snapshot.
  * debian/patches/exec_filename_exec.patch,exec_filename_fs.patch,
    exec_filename_use.patch: Keep compatibility.
  * debian/patches/exec_filename_fix.patch: Remove, merged upstream.

 -- Samuel Thibault <sthibault@debian.org>  Tue, 09 Jan 2018 00:24:18 +0000

hurd (1:0.9.git20171119-3) unstable; urgency=medium

  * patches/hash-weakref: New patch to fix use-after-free. Closes: Bug#882507.

 -- Samuel Thibault <sthibault@debian.org>  Tue, 19 Dec 2017 20:09:37 +0000

hurd (1:0.9.git20171119-2) unstable; urgency=medium

  * patches/pie-core: New patch to add at_entry note for PIE core dumps.

 -- Samuel Thibault <sthibault@debian.org>  Mon, 11 Dec 2017 01:40:05 +0000

=== debian/rules ===
#!/usr/bin/make -f
# -*- mode: makefile; coding: utf-8 -*-
# Copyright © 2003 Jeff Bailey <jbailey@debian.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2, or (at
# your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
# 02111-1307 USA.

export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-pie

DEB_DESTDIR = $(CURDIR)/debian/tmp
DEB_DESTDIR_UDEB = $(CURDIR)/debian/tmp-udeb
DEB_DESTDIR_PROF = $(CURDIR)/debian/tmp-prof

TRANSLATORS_PROF = auth exec ext2fs pfinet pflocal proc procfs term

ifeq (,$(filter stage1 stage2 stage3,$(DEB_BUILD_PROFILES)))
CONFIGURE_ARGS = --disable-profile --enable-static-progs='ext2fs,iso9660fs'
else
CONFIGURE_ARGS = \
		 --disable-ncursesw \
		 --without-libbz2 \
		 --without-libz \
		 --without-parted
# Skip some checks because they expect
# a working glibc causing a circular dependency.
# TODO: rather disable the corresponding features in configure.ac
export ac_cv_lib_pciaccess_pci_system_init=no
  ifneq (,$(filter stage1 stage2,$(DEB_BUILD_PROFILES)))
export ac_cv_search_clnt_create=no
export ac_cv_func_file_exec_file_name=no
export ac_cv_func_exec_exec_file_name=no
export ac_cv_func__hurd_exec_file_name=no
export ac_cv_func_file_exec_paths=no
export ac_cv_func_exec_exec_paths=no
export ac_cv_func__hurd_exec_paths=no
export LEX=:
export YACC=:
export MIG=:
  endif
endif
CONFIGURE_ARGS_deb =
CONFIGURE_ARGS_udeb = --without-libdaemon --without-libbz2
SUID_PROGRAMS = /bin/ids /bin/login /bin/ps-hurd /usr/bin/w-hurd

DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

INSTALL_in := $(wildcard debian/*.install.in)
INSTALL_generated := $(patsubst %.in,%,$(INSTALL_in))

BUILT_USING := $(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W libc0.3-dev libparted-dev zlib1g-dev libbz2-dev uuid-dev libblkid-dev)

ifeq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
       CC=gcc
else
       CC=$(DEB_HOST_GNU_TYPE)-gcc
endif

%:
	dh $@ -Bbuild-deb --with autotools_dev,autoreconf --parallel

override_dh_auto_configure:
	dh_auto_configure -Bbuild-deb -- $(CONFIGURE_ARGS) $(CONFIGURE_ARGS_deb) $(shell dpkg-buildflags --export=configure)
ifeq (,$(filter noprof,$(DEB_BUILD_PROFILES)))
	dh_auto_configure -Bbuild-prof -- $(CONFIGURE_ARGS) $(CONFIGURE_ARGS_deb) $(shell DEB_CFLAGS_APPEND=-pg dpkg-buildflags --export=configure)
endif
ifeq (,$(filter stage1 stage2 stage3 noudeb,$(DEB_BUILD_PROFILES)))
	dh_auto_configure -Bbuild-udeb -- $(CONFIGURE_ARGS) $(CONFIGURE_ARGS_udeb) $(shell dpkg-buildflags --export=configure)
endif

override_dh_auto_build:
ifneq (,$(filter stage1 stage2,$(DEB_BUILD_PROFILES)))
	:
  ifneq (,$(filter stage2,$(DEB_BUILD_PROFILES)))
	$(MAKE) -C build-deb/libihash libihash.a
  endif
else
  ifeq (,$(filter noudeb,$(DEB_BUILD_PROFILES)))
	dh_auto_build -Bbuild-udeb
  endif
	dh_auto_build -Bbuild-deb
ifeq (,$(filter noprof,$(DEB_BUILD_PROFILES)))
	dh_auto_build -Bbuild-prof
	for i in $(TRANSLATORS_PROF) ; do \
		$(MAKE) -C build-prof/$$i $$i.static ; \
	      done
endif
	cd build-deb/doc && make && makeinfo --html --split=chapter ../../doc/hurd.texi
  ifeq (,$(filter stage3,$(DEB_BUILD_PROFILES)))
	$(MAKE) -C libdde-linux26 BUILDDIR=$(CURDIR)/build-deb LDFLAGS= CC=$(CC)
  endif
endif

override_dh_auto_clean:
	dh_auto_clean -Bbuild-deb
ifeq (,$(filter noprof,$(DEB_BUILD_PROFILES)))
	dh_auto_clean -Bbuild-prof
endif
ifeq (,$(filter stage1 stage2 stage3 noudeb,$(DEB_BUILD_PROFILES)))
	dh_auto_clean -Bbuild-udeb
endif
	$(MAKE) -C libdde-linux26 cleanall
	rm -f $$(find libdde-linux26 -name \*.d)
	rm -fr libdde-linux26/build
	rm -fr libdde-linux26/lib/src/gen_crc32table libdde-linux26/lib/src/crc32table.h libdde-linux26/lib/src/timeconst.h
	rm -f $(INSTALL_generated)

override_dh_auto_install:
ifneq (,$(filter stage1 stage2,$(DEB_BUILD_PROFILES)))
	$(MAKE) -Cbuild-deb prefix=$(DEB_DESTDIR) install-headers no_deps=t
  ifneq (,$(filter stage2,$(DEB_BUILD_PROFILES)))
	$(MAKE) -Cbuild-deb/libihash libdir=$(DEB_DESTDIR)/lib/$(DEB_HOST_MULTIARCH) $(DEB_DESTDIR)/lib/$(DEB_HOST_MULTIARCH)/libihash.a
  endif
else
	dh_auto_install -Bbuild-deb -- prefix=$(DEB_DESTDIR) libdir=$(DEB_DESTDIR)/lib/$(DEB_HOST_MULTIARCH) libexecdir=$(DEB_DESTDIR)/lib/hurd sysconfdir=$(DEB_DESTDIR)/etc localstatedir=$(DEB_DESTDIR)/var XKB_BASE=$(DEB_DESTDIR)/usr/share/X11/xkb
ifeq (,$(filter noprof,$(DEB_BUILD_PROFILES)))
	install -d $(DEB_DESTDIR_PROF)/hurd
	for i in $(TRANSLATORS_PROF) ; do \
		install -m 755 build-prof/$$i/$$i.static $(DEB_DESTDIR_PROF)/hurd/$$i.prof ; \
	done
endif
ifeq (,$(filter noudeb,$(DEB_BUILD_PROFILES)))
	dh_auto_install -Bbuild-udeb -- prefix=$(DEB_DESTDIR_UDEB) libdir=$(DEB_DESTDIR_UDEB)/lib libexecdir=$(DEB_DESTDIR_UDEB)/lib/hurd sysconfdir=$(DEB_DESTDIR_UDEB)/etc localstatedir=$(DEB_DESTDIR_UDEB)/var XKB_BASE=$(DEB_DESTDIR_UDEB)/usr/share/X11/xkb
endif
  ifeq (,$(filter stage3,$(DEB_BUILD_PROFILES)))
	$(MAKE) -C libdde-linux26 INSTALLDIR=$(CURDIR)/debian/tmp/usr/share/libdde_linux26/build/include install
  endif

	# runsystem is managed by update-alternatives
	mv debian/tmp/lib/hurd/runsystem debian/tmp/lib/hurd/runsystem.gnu

	# move away fakeroot, ps, uptime, vmstat and w to not conflict with the
	# ones  from other packages
	mkdir -p debian/tmp/usr/bin
	mv debian/tmp/bin/fakeroot debian/tmp/usr/bin/fakeroot-hurd
	mv debian/tmp/bin/ps debian/tmp/bin/ps-hurd
	mv debian/tmp/bin/uptime debian/tmp/usr/bin/uptime-hurd
	mv debian/tmp/bin/vmstat debian/tmp/usr/bin/vmstat-hurd
	mv debian/tmp/bin/w debian/tmp/usr/bin/w-hurd
ifeq (,$(filter stage1 stage2 stage3 noudeb,$(DEB_BUILD_PROFILES)))
	mkdir -p debian/tmp-udeb/usr/bin
	mv debian/tmp-udeb/bin/ps debian/tmp-udeb/bin/ps-hurd
	mv debian/tmp-udeb/bin/uptime debian/tmp-udeb/usr/bin/uptime-hurd
	mv debian/tmp-udeb/bin/vmstat debian/tmp-udeb/usr/bin/vmstat-hurd
	mv debian/tmp-udeb/bin/w debian/tmp-udeb/usr/bin/w-hurd
endif

	# move away halt and reboot to not conflict with sysvinit
	# (they will be handled as alternatives)
	mv debian/tmp/sbin/halt debian/tmp/sbin/halt-hurd
	mv debian/tmp/sbin/reboot debian/tmp/sbin/reboot-hurd

	# remove PIC static libraries
	rm -f debian/tmp/lib/$(DEB_HOST_MULTIARCH)/*_pic.a
	rm -f debian/tmp-udeb/lib/*_pic.a
endif

override_dh_install: $(INSTALL_generated)
ifeq (,$(filter stage1 stage2 stage3 noudeb,$(DEB_BUILD_PROFILES)))
	dh_install $(addprefix -p,$(filter %-udeb,$(shell dh_listpackages))) --sourcedir=debian/tmp-udeb
endif
ifeq (,$(filter noprof,$(DEB_BUILD_PROFILES)))
	dh_install -phurd-prof --sourcedir=debian/tmp-prof
endif
	dh_install --remaining-packages --list-missing --sourcedir=debian/tmp
ifeq (,$(filter stage1 stage2 stage3 noudeb,$(DEB_BUILD_PROFILES)))
	mkdir -p debian/hurd-udeb/usr/share/lintian/overrides
	install -p -m644 debian/hurd-udeb.lintian-overrides debian/hurd-udeb/usr/share/lintian/overrides/hurd-udeb
endif

override_dh_installinit:
	dh_installinit -phurd --name=hurd-console
	dh_installinit --remaining-packages

override_dh_installchangelogs:
	dh_installchangelogs -XChangeLog

override_dh_strip:
ifeq (,$(filter stage1 stage2,$(DEB_BUILD_PROFILES)))
	dh_strip -phurd-libs0.3 -phurd --ddeb-migration='hurd-dbg (<< 1:0.7.git20160114-2~)'
endif
	dh_strip -Nhurd-prof --remaining-packages

override_dh_fixperms:
	dh_fixperms
ifeq (,$(filter stage1 stage2,$(DEB_BUILD_PROFILES)))
	chmod u+s $(patsubst %,$(CURDIR)/debian/hurd%,$(SUID_PROGRAMS))
endif

override_dh_makeshlibs:
	dh_makeshlibs -phurd-libs0.3 --add-udeb=hurd-libs0.3-udeb

## hurd 0.9.git20220218

=== debian/changelog ===
hurd (1:0.9.git20220218-1) unstable; urgency=medium

  * New upstream snapshot.

 -- Samuel Thibault <sthibault@debian.org>  Fri, 18 Feb 2022 00:57:33 +0000

hurd (1:0.9.git20220206-1) unstable; urgency=medium

  * New upstream snapshot.
    - patches/git-random-getrandom.patch: Upstreamed.
    - patches/git-exec-pie.patch: Upstreamed.
    - patches/git-random-time.patch: Upstreamed.
    - patches/git-server_name.patch: Upstreamed.
    - patches/git-login-cloexec.patch: Upstreamed.
    - patches/git-login-leaks.patch: Upstreamed.
    - patches/git-portinfo.patch: Upstreamed.
    - patches/git-portinfo2.patch: Upstreamed.
    - patches/git-const.patch: Upstreamed.
    - patches/rumpdisk-no-hd: Disable rumpdisk even with IDE drivers in
      gnumach.

 -- Samuel Thibault <sthibault@debian.org>  Sun, 06 Feb 2022 19:34:58 +0000

hurd (1:0.9.git20211230-5) unstable; urgency=medium

  * patches: Fix build warnings.
  * control: Bump Standards-Version to 4.6.0 (no change)
  * patches/git-const.patch: Constify RPCs server-side.
    - control: Bump gnumach-dev build-dep accordingly.
    - control: Bump mig build-dep accordingly.

 -- Samuel Thibault <sthibault@debian.org>  Sun, 16 Jan 2022 17:58:07 +0000

hurd (1:0.9.git20211230-4) unstable; urgency=medium

  * patches/git-login-leaks.patch: Fix some ports leaks.
  * patches/git-portinfo.patch: Make portinfo give much more information.
  * patches/git-portinfo2.patch: Fix deadname bug.

 -- Samuel Thibault <sthibault@debian.org>  Tue, 04 Jan 2022 00:29:09 +0000

hurd (1:0.9.git20211230-3) unstable; urgency=medium

  * patches/git-server_name.patch: random: export __trivfs_server_name.
  * patches/git-login-cloexec.patch: Fix auth port leak.

 -- Samuel Thibault <sthibault@debian.org>  Sun, 02 Jan 2022 00:26:33 +0000

hurd (1:0.9.git20211230-2) unstable; urgency=medium

  * control: Bump gnumach-dev build-dep to fix vm_size_array_t.
  * patches/git-random-time.patch: Fix loop between random and storeio
    initialization with glibc 2.34.

 -- Samuel Thibault <sthibault@debian.org>  Fri, 31 Dec 2021 08:36:11 +0000

hurd (1:0.9.git20211230-1) unstable; urgency=medium

  * New upstream snapshot.
    - patches/git-dealloc: Upstreamed.
    - patches/git-fix-install-pci-arbiter: Upstreamed.
    - patches/git-fix-symlink-frobbing: Upstreamed.
    - patches/git-fix-symlink-translator: Upstreamed.
    - patches/git-fix-sync: Upstreamed.
    - patches/git-fix_fsys_init_parent_proc: Upstreamed.
    - patches/git-fix_libmachdev_dosync: Upstreamed.
    - patches/git-libstore_offset_check: Upstreamed.
    - patches/git-next_task: Upstreamed.
    - patches/git-notirpc: Upstreamed.
    - patches/git-optim: Upstreamed.
    - patches/git-optim2: Upstreamed.
    - patches/git-rump_alloc.patch: Upstreamed.
    - patches/git-tirpc: Upstreamed.
    - patches/git-exec-pie.patch: Only constraint loading the ELF interpreter.
    - patches/git-random-getrandom.patch: Add a trivfs_server_name.
    - control: Bump libc0.3-dev build-dep to get vm_region_create_proxy.
  * rules: Update stage1 configure pre-caching.

 -- Samuel Thibault <sthibault@debian.org>  Thu, 30 Dec 2021 15:16:18 +0000

hurd (1:0.9.git20210811-5) unstable; urgency=medium

  * patches/git-rump_alloc.patch: Ensure physical allocation of memory for DMA
    reads.
  * patches/git-notirpc: Really make libtirpc optional, for bootstrap.

 -- Samuel Thibault <sthibault@debian.org>  Tue, 24 Aug 2021 12:14:51 +0000

hurd (1:0.9.git20210811-4) unstable; urgency=medium

  * patches/exec_filename_exec.patch: Drop server part.
  * patches/exec_filename_fs.patch: Drop server part.
  * patches/exec_filename_use.patch: Drop.
  * local/runsystem.sysv: Replace "which" by "command -v".
  * patches/libstore_offset_check: Detect device-based access overflow.
  * patches/tirpc: Use libtirpc.
  * control: Add libtirpc-dev build-dep.
  * patches/dealloc: Add missing deallocation in rumpdisk.

 -- Samuel Thibault <sthibault@debian.org>  Sun, 22 Aug 2021 00:32:45 +0000

hurd (1:0.9.git20210811-3) unstable; urgency=medium

  * debian/patches/optim: Add ext2fs optimisation.
  * debian/patches/optim2: Add general optimisation.

 -- Samuel Thibault <sthibault@debian.org>  Wed, 11 Aug 2021 23:49:35 +0000

hurd (1:0.9.git20210811-2) unstable; urgency=medium

  * debian/patches/fix-symlink-translator: Fix block allocation when
    converting a symlink to a translator node.
  * debian/patches/fix_fsys_init_parent_proc: Fix setting bootstrap tasks
    arguments.
  * debian/patches/fix-install-pci-arbiter: Fix pci-arbiter showing up in
    /servers/bus/pci
  * debian/patches/fix_libmachdev_dosync: Fix libmachdev behavior at shutdown.
  * debian/patches/next_task: Rename options for bootstrap chain.
  * debian/patches/fix-symlink-frobbing: Fix frobbing symlinks. This should
    reduce spurious error correction from ext2fs.
  * debian/patches/fix-sync: Fix syncing nodes getting removed.

 -- Samuel Thibault <sthibault@debian.org>  Wed, 11 Aug 2021 16:29:03 +0000

hurd (1:0.9.git20210811-1) unstable; urgency=medium

  * New upstream snapshot.
    - Fixes disappearance of /dev/urandom.
    - debian/patches/fix-truncate: upstreamed.
    - debian/patches/git-invalid-right: upstreamed.
    - debian/patches/git-libmachdev-non-bootstrap-fix.patch: upstreamed.
    - debian/patches/git-pci-arbiter-non-bootstrap-fix.patch: upstreamed.
    - debian/patches/git-pci-arbiter-option.patch: upstreamed.
    - debian/patches/git-trivfs_server.patch: upstreamed.

 -- Samuel Thibault <sthibault@debian.org>  Wed, 11 Aug 2021 02:29:43 +0000

hurd (1:0.9.git20210404-9) unstable; urgency=medium

  [ Sergey Bugaev ]
  * patches/00*: Fix read-only mapping security issue.

  [ Samuel Thibault ]
  * control: Bump gnumach break, since we need gnumach fixes for proper object
    cleanup.
  * patches/restore_proc_setowner_request: Rework into RPC-rename, for more
    coherent RPC names.

 -- Samuel Thibault <sthibault@debian.org>  Mon, 09 Aug 2021 18:21:08 +0000



=== debian/control ===
Source: hurd
Section: admin
Priority: required
Maintainer: GNU Hurd Maintainers <debian-hurd@lists.debian.org>
Standards-Version: 4.6.0
Build-Depends:
 mig-for-host (>= 1.8+git20200618-7~) <!stage1 !stage2>,
 gnumach-dev (>= 2:1.8+git20211230-7~) <!stage1>,
 libc0.3-dev (>= 2.33-2~1) <!stage1>, texinfo,
 debhelper-compat (= 12), dpkg-dev (>= 1.17.14), dh-exec (>= 0.17),
 gawk, flex, bison,
 libgcrypt20-dev <!stage1 !stage2>,
 libncursesw5-dev <!stage1 !stage2>,
 libparted-dev <!stage1 !stage2>,
 librumpdev-disk-dev <!stage1 !stage2>,
 libpciaccess-dev <!stage1 !stage2>,
 libtirpc-dev <!stage1 !stage2>,
 libx11-dev <!stage1 !stage2>,
 x11proto-core-dev <!stage1 !stage2>,
 pkg-config <!stage1 !stage2>,
 xkb-data <!stage1 !stage2>,
 libdaemon-dev <!stage1 !stage2>,
 libpcap0.8-dev <!stage1 !stage2>,
 zlib1g-dev <!stage1 !stage2>,
 libbz2-dev <!stage1 !stage2>,
 uuid-dev <!stage1 !stage2>,
 libblkid-dev <!stage1 !stage2>,
 liblwip-dev <!stage1 !stage2>
Uploaders: Michael Banck <mbanck@debian.org>, 
 Samuel Thibault <sthibault@debian.org>
Homepage: http://www.gnu.org/software/hurd/hurd.html
Vcs-Browser: https://salsa.debian.org/hurd-team/hurd
Vcs-Git: https://salsa.debian.org/hurd-team/hurd.git

Package: hurd-libs0.3
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: netdde (<< 0.0.20200330-8~)
Architecture: hurd-any
Build-Profiles: <!stage1>
Multi-Arch: same
Description: GNU Hurd (libraries)
 This package contains the libraries used by GNU Hurd.

Package: hurd
Essential: yes
Pre-Depends: hurd-libs0.3, ${misc:Pre-Depends}
Depends: ${misc:Depends}, lsb-base (>= 3.0-6), hurd-libs0.3 (= ${binary:Version}), sysv-rc <!stage2> | openrc <!stage2>, ${shlibs:Depends}, xkb-data <!stage2>
Breaks: gnumach-image-1-486 (<< 2:1.8+git20210809-1~),
	gnumach-image-1-xen-486 (<< 2:1.8+git20210809-1~),
	gnumach-image-1.8-486 (<< 2:1.8+git20210809-1~),
	gnumach-image-1.8-486-dbg (<< 2:1.8+git20210809-1~),
	gnumach-image-1.8-xen-486 (<< 2:1.8+git20210809-1~),
	gnumach-image-1.8-xen-486-dbg (<< 2:1.8+git20210809-1~),
	libc0.3 (<< 2.31-13+hurd.1~), netdde (<< 0.0.20121127-2)
Built-Using: ${built-using}
Suggests: hurd-doc
Recommends: bf-utf-source, netdde (>= 0.0.20120518~) <!stage2>
Provides: makedev, login, console-driver-xkb
Replaces: makedev, login (<< 1:4.0.14-4), random-egd, console-driver-xkb, initscripts (<< 2.95-4A)
Conflicts: makedev, login (<< 1:4.0.14-4), console-driver-xkb
Architecture: hurd-any
Build-Profiles: <!stage1>
Description: GNU Hurd
 This is the GNU Hurd package. It contains essential system software and
 libraries.

Package: hurd-prof
Priority: optional
Pre-Depends: hurd-libs0.3
Depends: ${misc:Depends}, hurd-libs0.3 (= ${binary:Version}), ${shlibs:Depends}, xkb-data <!stage2>
Breaks: gnumach (<< 2:1.3.99.dfsg.cvs20070526-1), libc0.3 (<< 2.19-15~), netdde (<< 0.0.20121127-2)
Built-Using: ${built-using}
Suggests: hurd-doc
Recommends: bf-utf-source
Architecture: hurd-any
Build-Profiles: <!stage1 !pkg.hurd.noprof>
Description: GNU Hurd
 This is the GNU Hurd package. It contains essential system software and
 libraries, with gprof profiling enabled.

Package: hurd-dev
Priority: standard
Section: libdevel
Architecture: hurd-any
Depends: ${misc:Depends}, ${shlibs:Depends}, ${perl:Depends},
 libc0.3-dev (>= 2.13-31~) <!stage1>,
 hurd-libs0.3 (= ${binary:Version}) <!stage1>,
 hurd (= ${binary:Version}) <!stage2>
Provides: hurd-headers-dev, libihash-dev, libdde-linux26-dev <!stage2>
Replaces: hurd (<< 20130226-2~), hurd-headers-dev, libihash-dev
Breaks: hurd (<< 20130226-2~), hurd-headers-dev, libihash-dev
Build-Profiles: <!stage1>
Description: GNU Hurd (development files)
 This package includes the header files and the static libraries.

Package: hurd-headers-dev
Priority: standard
Section: libdevel
Architecture: hurd-any
Depends: ${misc:Depends}, ${shlibs:Depends}
Build-Profiles: <stage1>
Description: GNU Hurd (development files)
 This package includes the header files and the static libraries.
 .
 This package is only used for bootstrap, it contains headers needed for libc

Package: hurd-doc
Priority: optional
Section: doc
Architecture: all
Multi-Arch: foreign
Build-Profiles: <!stage1>
Depends: ${misc:Depends}
Suggests: www-browser
Description: GNU Hurd manual
 This package includes the manual in info and HTML format.

Package: hurd-libs0.3-udeb
Section: debian-installer
Package-Type: udeb
Priority: optional
Architecture: hurd-any
Build-Profiles: <!noudeb !stage1 !stage2>
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: GNU Hurd (libraries) - udeb
 This package contains the libraries used by GNU Hurd udeb.

Package: hurd-udeb
Package-Type: udeb
Priority: optional
Section: debian-installer
Architecture: hurd-any
Build-Profiles: <!noudeb !stage1 !stage2>
Depends: ${misc:Depends}, ${shlibs:Depends}, hurd-libs0.3-udeb (= ${binary:Version}), xkb-data-udeb
Built-Using: ${built-using}
Provides: hurd, ext2-modules, fat-modules, ipv6-modules, isofs-modules, loop-modules, mouse-modules, nfs-modules, socket-modules
Description: GNU Hurd - udeb
 This is the GNU Hurd udeb package. It contains essential system software and
 libraries.

=== debian/rules ===
#!/usr/bin/make -f
# -*- mode: makefile; coding: utf-8 -*-
# Copyright © 2003 Jeff Bailey <jbailey@debian.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2, or (at
# your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
# 02111-1307 USA.

include /usr/share/dpkg/architecture.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-pie

DEB_DESTDIR = $(CURDIR)/debian/tmp
DEB_DESTDIR_UDEB = $(CURDIR)/debian/tmp-udeb
DEB_DESTDIR_PROF = $(CURDIR)/debian/tmp-prof

TRANSLATORS_PROF = auth exec ext2fs pci-arbiter pfinet lwip pflocal proc procfs term

CONFIGURE_ARGS = --build=$(DEB_BUILD_GNU_TYPE) --host=$(DEB_HOST_GNU_TYPE)
ifeq (,$(filter stage1 stage2,$(DEB_BUILD_PROFILES)))
CONFIGURE_ARGS += --disable-profile --enable-static-progs='ext2fs,iso9660fs,rumpdisk,pci-arbiter,acpi'
else
CONFIGURE_ARGS += \
		 --disable-ncursesw \
		 --without-libbz2 \
		 --without-libz \
		 --without-parted \
		 --without-libcrypt
# Skip some checks because they expect
# a working glibc causing a circular dependency.
# TODO: rather disable the corresponding features in configure.ac
export ac_cv_lib_pciaccess_pci_system_init=no
  ifneq (,$(filter stage1,$(DEB_BUILD_PROFILES)))
export ac_cv_search_clnt_create=no
export ac_cv_func_file_exec_paths=no
export ac_cv_func_exec_exec_paths=no
export ac_cv_func__hurd_exec_paths=no
export ac_cv_func__hurd_libc_proc_init=no
export ac_cv_func_file_futimens=no
export LEX=:
export YACC=:
export MIG=:
  endif
endif
CONFIGURE_ARGS += prefix=/ includedir=/usr/include libdir=/lib/$(DEB_HOST_MULTIARCH) libexecdir=/usr/libexec datarootdir=/usr/share sysconfdir=/etc localstatedir=/var
CONFIGURE_ARGS_deb =
CONFIGURE_ARGS_udeb = libdir=/lib --without-libdaemon --without-libbz2
SUID_PROGRAMS = /bin/ids /bin/login /bin/ps-hurd /usr/bin/w-hurd

INSTALL_in := $(wildcard debian/*.install.in)
INSTALL_generated := $(patsubst %.in,%,$(INSTALL_in))

BUILT_USING := $(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W libc0.3-dev libparted-dev zlib1g-dev libbz2-dev uuid-dev libblkid-dev)

ifeq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
       CC=gcc
else
       CC=$(DEB_HOST_GNU_TYPE)-gcc
endif

%:
	dh $@ -Bbuild-deb

# Avoid re-running configure each time. See Bug#966707
override_dh_auto_configure: debian/configure-stamp
debian/configure-stamp:
	dh_auto_configure -Bbuild-deb -- $(CONFIGURE_ARGS) $(CONFIGURE_ARGS_deb) $(shell dpkg-buildflags --export=configure)
ifeq (,$(filter pkg.hurd.noprof,$(DEB_BUILD_PROFILES)))
	dh_auto_configure -Bbuild-prof -- $(CONFIGURE_ARGS) $(CONFIGURE_ARGS_deb) $(shell DEB_CFLAGS_MAINT_APPEND=-pg dpkg-buildflags --export=configure)
endif
ifeq (,$(filter stage1 stage2 noudeb,$(DEB_BUILD_PROFILES)))
	dh_auto_configure -Bbuild-udeb -- $(CONFIGURE_ARGS) $(CONFIGURE_ARGS_udeb) $(shell dpkg-buildflags --export=configure)
endif
	touch $@

override_dh_auto_build:
ifneq (,$(filter stage1,$(DEB_BUILD_PROFILES)))
	:
else
  ifeq (,$(filter noudeb,$(DEB_BUILD_PROFILES)))
	dh_auto_build -Bbuild-udeb
  endif
	dh_auto_build -Bbuild-deb
ifeq (,$(filter pkg.hurd.noprof,$(DEB_BUILD_PROFILES)))
	dh_auto_build -Bbuild-prof
	for i in $(TRANSLATORS_PROF) ; do \
		$(MAKE) -C build-prof/$$i $$i.static ; \
	      done
endif
	cd build-deb/doc && make && makeinfo --html --split=chapter ../../doc/hurd.texi
  ifeq (,$(filter stage2,$(DEB_BUILD_PROFILES)))
	$(MAKE) -C libdde-linux26 BUILDDIR=$(CURDIR)/build-deb LDFLAGS= CC=$(CC)
  endif
endif

override_dh_auto_clean:
	dh_auto_clean -Bbuild-deb
ifeq (,$(filter pkg.hurd.noprof,$(DEB_BUILD_PROFILES)))
	dh_auto_clean -Bbuild-prof
endif
ifeq (,$(filter stage1 stage2 noudeb,$(DEB_BUILD_PROFILES)))
	dh_auto_clean -Bbuild-udeb
endif
	$(MAKE) -C libdde-linux26 cleanall
	rm -f $$(find libdde-linux26 -name \*.d)
	rm -fr libdde-linux26/build
	rm -fr libdde-linux26/lib/src/gen_crc32table libdde-linux26/lib/src/crc32table.h libdde-linux26/lib/src/timeconst.h
	rm -f $(INSTALL_generated)

override_dh_auto_install:
ifneq (,$(filter stage1,$(DEB_BUILD_PROFILES)))
	$(MAKE) -Cbuild-deb DESTDIR=$(DEB_DESTDIR) install-headers no_deps=t
else
	dh_auto_install -Bbuild-deb --destdir=$(DEB_DESTDIR)
ifeq (,$(filter pkg.hurd.noprof,$(DEB_BUILD_PROFILES)))
	install -d $(DEB_DESTDIR_PROF)/hurd
	for i in $(TRANSLATORS_PROF) ; do \
		install -m 755 build-prof/$$i/$$i.static $(DEB_DESTDIR_PROF)/hurd/$$i.prof ; \
	done
endif
ifeq (,$(filter noudeb,$(DEB_BUILD_PROFILES)))
	dh_auto_install -Bbuild-udeb --destdir=$(DEB_DESTDIR_UDEB)
endif
ifeq (,$(filter stage2,$(DEB_BUILD_PROFILES)))
	$(MAKE) -C libdde-linux26 INSTALLDIR=$(CURDIR)/debian/tmp/usr/share/libdde_linux26/build/include install
endif

	# runsystem is managed by update-alternatives
	mv debian/tmp/usr/libexec/runsystem debian/tmp/usr/libexec/runsystem.gnu

	# move away fakeroot, ps, uptime, vmstat and w to not conflict with the
	# ones  from other packages
	mkdir -p debian/tmp/usr/bin
	mv debian/tmp/bin/fakeroot debian/tmp/usr/bin/fakeroot-hurd
	mv debian/tmp/bin/ps debian/tmp/bin/ps-hurd
	mv debian/tmp/bin/uptime debian/tmp/usr/bin/uptime-hurd
	mv debian/tmp/bin/vmstat debian/tmp/usr/bin/vmstat-hurd
	mv debian/tmp/bin/w debian/tmp/usr/bin/w-hurd
ifeq (,$(filter stage1 stage2 noudeb,$(DEB_BUILD_PROFILES)))
	mkdir -p debian/tmp-udeb/usr/bin
	mv debian/tmp-udeb/bin/ps debian/tmp-udeb/bin/ps-hurd
	mv debian/tmp-udeb/bin/uptime debian/tmp-udeb/usr/bin/uptime-hurd
	mv debian/tmp-udeb/bin/vmstat debian/tmp-udeb/usr/bin/vmstat-hurd
	mv debian/tmp-udeb/bin/w debian/tmp-udeb/usr/bin/w-hurd
endif

	# move away halt and reboot to not conflict with sysvinit
	# (they will be handled as alternatives)
	mv debian/tmp/sbin/halt debian/tmp/sbin/halt-hurd
	mv debian/tmp/sbin/reboot debian/tmp/sbin/reboot-hurd

	# remove PIC static libraries
	rm -f debian/tmp/lib/$(DEB_HOST_MULTIARCH)/*_pic.a
	rm -f debian/tmp-udeb/lib/*_pic.a
endif

override_dh_install: $(INSTALL_generated)
ifeq (,$(filter stage1 stage2 noudeb,$(DEB_BUILD_PROFILES)))
	dh_install $(addprefix -p,$(filter %-udeb,$(shell dh_listpackages))) --sourcedir=debian/tmp-udeb
	mkdir -p debian/hurd-udeb/usr/share/lintian/overrides
	install -p -m644 debian/hurd-udeb.lintian-overrides debian/hurd-udeb/usr/share/lintian/overrides/hurd-udeb
	sed -i -e '1s/bash/sh/' debian/hurd-udeb/sbin/MAKEDEV
	# We need /servers/exec and startup at boot time
	touch debian/hurd-udeb/servers/exec
	touch debian/hurd-udeb/servers/startup
endif
ifeq (,$(filter pkg.hurd.noprof,$(DEB_BUILD_PROFILES)))
	dh_install -phurd-prof --sourcedir=debian/tmp-prof
endif
	dh_install --remaining-packages --sourcedir=debian/tmp

override_dh_installinit:
	dh_installinit -phurd --name=hurd-console
	dh_installinit --remaining-packages

override_dh_installchangelogs:
	dh_installchangelogs -XChangeLog

override_dh_missing:
	dh_missing --list-missing

override_dh_strip:
	dh_strip -Nhurd-prof -Xlibdde

override_dh_fixperms-arch:
	dh_fixperms -a
ifeq (,$(filter stage1,$(DEB_BUILD_PROFILES)))
	chmod u+s $(patsubst %,$(CURDIR)/debian/hurd%,$(SUID_PROGRAMS))
endif

override_dh_makeshlibs:
ifeq (,$(filter stage1 stage2 noudeb,$(DEB_BUILD_PROFILES)))
	dh_makeshlibs -phurd-libs0.3 --add-udeb=hurd-libs0.3-udeb
endif
	dh_makeshlibs --remaining-packages -Xusr/lib/hurd/

override_dh_gencontrol:
	dh_gencontrol -- -V"built-using=$(BUILT_USING)"

override_dh_clean:
	dh_clean
	rm -rf debian/tmp-udeb
	rm -rf debian/tmp-prof
	rm -f debian/configure-stamp

debian/%.install: debian/%.install.in
